aboutsummaryrefslogtreecommitdiff
path: root/nx-X11/programs/xterm/uxterm
diff options
context:
space:
mode:
authorReinhard Tartler <siretart@tauware.de>2011-10-10 17:43:39 +0200
committerReinhard Tartler <siretart@tauware.de>2011-10-10 17:43:39 +0200
commitf4092abdf94af6a99aff944d6264bc1284e8bdd4 (patch)
tree2ac1c9cc16ceb93edb2c4382c088dac5aeafdf0f /nx-X11/programs/xterm/uxterm
parenta840692edc9c6d19cd7c057f68e39c7d95eb767d (diff)
downloadnx-libs-f4092abdf94af6a99aff944d6264bc1284e8bdd4.tar.gz
nx-libs-f4092abdf94af6a99aff944d6264bc1284e8bdd4.tar.bz2
nx-libs-f4092abdf94af6a99aff944d6264bc1284e8bdd4.zip
Imported nx-X11-3.1.0-1.tar.gznx-X11/3.1.0-1
Summary: Imported nx-X11-3.1.0-1.tar.gz Keywords: Imported nx-X11-3.1.0-1.tar.gz into Git repository
Diffstat (limited to 'nx-X11/programs/xterm/uxterm')
-rw-r--r--nx-X11/programs/xterm/uxterm82
1 files changed, 82 insertions, 0 deletions
diff --git a/nx-X11/programs/xterm/uxterm b/nx-X11/programs/xterm/uxterm
new file mode 100644
index 000000000..6e8f72032
--- /dev/null
+++ b/nx-X11/programs/xterm/uxterm
@@ -0,0 +1,82 @@
+#!/bin/sh
+# $XTermId: uxterm,v 1.20 2005/08/05 01:25:40 tom Exp $
+# $XFree86: xc/programs/xterm/uxterm,v 1.11 2005/08/05 01:25:40 dickey Exp $
+# wrapper script to setup xterm with UTF-8 locale
+
+program=xterm
+
+# Check if there is a workable locale program. If there is not, we will read
+# something via the standard error. Ignore whatever is written to the
+# standard output.
+locale=`sh -c "LC_ALL=C LC_CTYPE=C LANG=C locale >/dev/null" 2>&1`
+found=no
+
+# Check for -version and -help options, to provide a simple return without
+# requiring the program to create a window:
+if test $# = 1
+then
+ case $1 in
+ -v|-ver*|-h|-he*)
+ $program "$@"
+ exit $?
+ ;;
+ esac
+fi
+
+# Check environment variables that xterm does, in the same order:
+for name in LC_ALL LC_CTYPE LANG
+do
+ eval 'value=$'$name
+ if test -n "$value" ; then
+ case $value in
+ *.utf8|*.UTF8|*.utf-8|*.UTF-8)
+ found=yes
+ ;;
+ *.utf8@*|*.UTF8@*|*.utf-8@*|*.UTF-8@*)
+ found=yes
+ ;;
+ C|POSIX)
+ # Yes, I know this is not the same - but why are you
+ # here then?
+ value=en_US
+ ;;
+ esac
+ break
+ fi
+done
+
+# If we didn't find one that used UTF-8, modify the safest one. Not everyone
+# has a UTF-8 locale installed (and there appears to be no trivial/portable way
+# to determine whether it is, from a shell script). We could check if the
+# user's shell does not reset unknown locale specifiers, but not all shells do.
+if test $found != yes ; then
+ if test -n "$value" ; then
+ value=`echo ${value} |sed -e 's/[.@].*//'`.UTF-8
+ else
+ name="LC_CTYPE"
+ value="en_US.UTF-8"
+ fi
+ eval save=\$${name}
+ eval ${name}=${value}
+ eval export ${name}
+ if test -z "$locale" ; then
+ # The 'locale' program tries to do a sanity check.
+ check=`sh -c "locale >/dev/null" 2>&1`
+ if test -n "$check" ; then
+ eval ${name}=${save}
+ eval export ${name}
+
+ echo "uxterm tried to use locale $value by setting \$$name" >&2
+ xmessage -file - <<EOF
+uxterm tried unsuccessfully to use locale $value
+by setting \$$name to "${value}".
+EOF
+ exit 1
+ fi
+ fi
+fi
+
+# for testing:
+#test -f ./xterm && program=./xterm
+
+exec $program -class UXTerm -title 'uxterm' -u8 "$@"